SystemOrganization addCategory: #ConfigurationOfASTInterpreter!

Object subclass: #ConfigurationOfASTInterpreter
	instanceVariableNames: 'project'
	classVariableNames: 'lastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfASTInterpreter'!

!ConfigurationOfASTInterpreter commentStamp: '<historical>' prior: 0!
(ConfigurationOfASTInterpreter project version: '0.4') load
!

!ConfigurationOfASTInterpreter class methodsFor: 'development support' stamp: 'ClementBera 12/4/2012 09:51'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfASTInterpreter class methodsFor: 'private' stamp: 'ClementBera 12/4/2012 09:54'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfASTInterpreter class methodsFor: 'catalog' stamp: 'StephaneDucasse 10/2/2013 08:02'!
catalogChangeLog
		
 ^ '

- Version 1. 4 02/10/2013 version 4 as the one in Pharo30 

[[[
(ConfigurationOfSoup project version: ''1.4'') load: ''pharo''
]]]

Note that the stable version is currently loading more recent versions that have not been integrated to Pharo3.0.
'
	
	! !

!ConfigurationOfASTInterpreter class methodsFor: 'catalog' stamp: 'StephaneDucasse 10/2/2013 07:56'!
catalogDescription

^ 
'AST interpreter is a full Pharo interpreter including exceptions, return, ensure: Smalltalk semantics. It is able to execute any Pharo code. It is developed by C. Bruni and C. Bera.'! !

!ConfigurationOfASTInterpreter class methodsFor: 'catalog' stamp: 'StephaneDucasse 10/2/2013 07:59'!
catalogKeyClassesAndExample

	^ 'It is composed of some keys classes: 
		
- ==ASTInterpreter== is the main class.

- The ==InterperterTest== class is the place to start to learn the API.'! !

!ConfigurationOfASTInterpreter class methodsFor: 'catalog' stamp: 'StephaneDucasse 10/2/2013 07:57'!
catalogKeywords
	^ #(semantics interpreter ast language)
	! !

!ConfigurationOfASTInterpreter class methodsFor: 'private' stamp: 'ClementBera 12/4/2012 09:54'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfASTInterpreter class methodsFor: 'private' stamp: 'ClementBera 12/4/2012 09:54'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfASTInterpreter class methodsFor: 'metacello tool support' stamp: 'ClementBera 12/4/2012 09:53'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfASTInterpreter class methodsFor: 'loading' stamp: 'ClementBera 12/4/2012 09:53'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfASTInterpreter class methodsFor: 'loading' stamp: 'ClementBera 12/4/2012 09:53'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfASTInterpreter class methodsFor: 'loading' stamp: 'ClementBera 12/4/2012 09:53'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfASTInterpreter class methodsFor: 'accessing' stamp: 'ClementBera 12/4/2012 09:52'!
project

	^self new project! !

!ConfigurationOfASTInterpreter class methodsFor: 'development support' stamp: 'ClementBera 12/4/2012 09:51'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'PavelKrivanek 2/9/2014 21:09'!
baseline01: spec
	<version: '0.1-baseline'>
	spec for: #common do: [
	spec  blessing: #baseline;
		repository: 'http://smalltalkhub.com/mc/Pharo/AST-Interpreter/main'.
	
	spec
		package: 'AST-Interpreter-Core'with:[
			spec requires: #('AST-Interpreter-Extension' 'AST-Interpreter-Semantic-Binding')];
		package: 'AST-Interpreter-Extension';
		package: 'AST-Interpreter-Semantic-Binding';
		package: 'AST-Interpreter-Test' with:[
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-PharoTest' with:[
			spec requires: #('AST-Interpreter-Test')].

	spec 
		group: 'default' with: #('AST-Interpreter-Core');
		group: 'test' with: #('AST-Interpreter-Test' 'AST-Interpreter-PharoTest').
	]! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'PavelKrivanek 2/9/2014 21:02'!
baseline02: spec
	<version: '0.2-baseline'>
	spec for: #common do: [
	spec  blessing: #baseline;
		repository: 'http://smalltalkhub.com/mc/Pharo/AST-Interpreter/main'.
	
	spec
		package: 'AST-Interpreter-Core'with:[
			spec requires: #('AST-Interpreter-Extension' 'AST-Interpreter-Semantic-Binding')];
		package: 'AST-Debugger'with:[
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-Extension';
		package: 'AST-Interpreter-Semantic-Binding';
		package: 'AST-Interpreter-Test' with:[
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-PharoTest' with:[
			spec requires: #('AST-Interpreter-Test')]. 
		
	spec 
		group: 'pharo' with: #('AST-Interpreter-Test');
		group: 'default' with: #('AST-Interpreter-Core');
		group: 'test' with: #('AST-Interpreter-Test' 'AST-Interpreter-PharoTest').
	]! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'StephaneDucasse 10/2/2013 07:48'!
baseline03: spec
	<version: '0.3-baseline'>
	spec for: #common do: [
	spec  blessing: #baseline;
		repository: 'http://smalltalkhub.com/mc/Pharo/AST-Interpreter/main'.
	
	spec
		package: 'AST-Interpreter-Core' with: [
			spec requires: #('AST-Interpreter-Extension')];
		package: 'AST-Debugger'with:[
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-Extension';
		package: 'AST-Interpreter-Test' with: [
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-PharoTest' with: [
			spec requires: #('AST-Interpreter-Test')].
		
	spec 
		group: 'pharo'		with: #('AST-Interpreter-Test');
		group: 'default'		with: #('AST-Interpreter-Core');
		group: 'test'		with: #('AST-Interpreter-Test' 'AST-Interpreter-PharoTest').
	]! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'StephaneDucasse 10/2/2013 07:45'!
baselineDEV: spec
	<version: '999-dev-baseline'>
	spec for: #common do: [
	spec  blessing: #baseline;
		repository: 'http://smalltalkhub.com/mc/Pharo/AST-Interpreter/main'.
	
	spec
		package: 'AST-Interpreter-Core' with: [
			spec requires: #('AST-Interpreter-Extension')];
		package: 'AST-Debugger'with:[
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-Extension';
		package: 'AST-Interpreter-Test' with: [
			spec requires: #('AST-Interpreter-Core')];
		package: 'AST-Interpreter-PharoTest' with: [
			spec requires: #('AST-Interpreter-Test')].
		
	spec 
		group: 'pharo'		with: #('AST-Interpreter-Test');
		group: 'default'		with: #('AST-Interpreter-Core');
		group: 'test'		with: #('AST-Interpreter-Test' 'AST-Interpreter-PharoTest').
	]! !

!ConfigurationOfASTInterpreter methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 10/2/2013 06:17'!
bleedingEdge: spec
	<symbolicVersion: #'bleedingEdge'>

	spec for: #'common' version: '03-baseline'.
! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'ClementBera 12/4/2012 09:50'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfASTInterpreter methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 10/2/2013 06:18'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.4'.
! !

!ConfigurationOfASTInterpreter methodsFor: 'baselines' stamp: 'ClementBera 12/4/2012 09:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfASTInterpreter methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 10/2/2013 06:18'!
stable: spec
	<symbolicVersion: #stable>

	spec for: #'common' version: '0.3'.! !

!ConfigurationOfASTInterpreter methodsFor: 'versions' stamp: 'ClementBera 4/12/2013 16:22'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>
	
	"This version is stable in Pharo 2.0"

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial dev version'.
		spec author: 'CamilloBruni'.
		spec timestamp: '1/15/2013 16:13'.
		spec  
			package: 'AST-Interpreter-Core' with: 'AST-Interpreter-Core-ClementBera.70';
			package: 'AST-Interpreter-Extension' with: 'AST-Interpreter-Extension-ClementBera.25';
			package: 'AST-Interpreter-PharoTest' with: 'AST-Interpreter-PharoTest-ClementBera.11';
			package: 'AST-Interpreter-Semantic-Binding' with: 'AST-Interpreter-Semantic-Binding-ClementBera.3';
			package: 'AST-Interpreter-Test' with: 'AST-Interpreter-Test-ClementBera.73'].
! !

!ConfigurationOfASTInterpreter methodsFor: 'versions' stamp: 'CamilloBruni 9/12/2013 14:25'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	"stable in Pharo 3.0"

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial dev version'.
		spec author: 'ClementBera'.
		spec timestamp: '04/04/2013 16:13'.
		"Authors: CamilloBruni ClementBera"
		spec  
			package: 'AST-Interpreter-Core' with: 'AST-Interpreter-Core-CamilloBruni.111';
			package: 'AST-Interpreter-Extension' with: 'AST-Interpreter-Extension-ClementBera.27';
			package: 'AST-Interpreter-PharoTest' with: 'AST-Interpreter-PharoTest-ClementBera.11';
			package: 'AST-Interpreter-Semantic-Binding' with: 'AST-Interpreter-Semantic-Binding-ClementBera.4';
			package: 'AST-Interpreter-Test' with: 'AST-Interpreter-Test-ClementBera.82';
			package: 'AST-Debugger' with: 'AST-Debugger-ClementBera.6';
			
			package: 'Eye' with: 'Eye-ClementBera.11'].
! !

!ConfigurationOfASTInterpreter methodsFor: 'versions' stamp: 'StephaneDucasse 10/2/2013 06:18'!
version03: spec
	<version: '0.3' imports: #('0.3-baseline' )>

	"stable in Pharo 3.0"

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial dev version'.
		spec author: 'ClementBera'.
		spec timestamp: '2013-09-12'.
		"Authors: CamilloBruni ClementBera"
		spec  
			package: 'AST-Interpreter-Core'		with: 'AST-Interpreter-Core-CamilloBruni.111';
			package: 'AST-Interpreter-Extension'	with: 'AST-Interpreter-Extension-ClementBera.37';
			package: 'AST-Interpreter-PharoTest'	with: 'AST-Interpreter-PharoTest-ClementBera.11';
			package: 'AST-Interpreter-Test'		with: 'AST-Interpreter-Test-CamilloBruni.87';
			package: 'AST-Debugger'				with: 'AST-Debugger-ClementBera.6'].
! !

!ConfigurationOfASTInterpreter methodsFor: 'versions' stamp: 'StephaneDucasse 10/2/2013 07:44'!
version04: spec
	<version: '0.4' imports: #('0.3-baseline' )>

	"stable in Pharo 3.0"

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'As in Pharo30 once integrated'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '2013-10-02'.
		spec  
			package: 'AST-Interpreter-Core'		with: 'AST-Interpreter-Core-StephaneDucasse.110';
			package: 'AST-Interpreter-Extension'	with: 'AST-Interpreter-Extension-MarcusDenker.36';
			package: 'AST-Interpreter-Test'		with: 'AST-Interpreter-Test-MarcusDenker.86'.
			"in Pharo 30 There is no"
			"package: 'AST-Interpreter-PharoTest'	with: 'AST-Interpreter-PharoTest-ClementBera.11';
			package: 'AST-Debugger'				with: 'AST-Debugger-ClementBera.6'"].
! !

!ConfigurationOfASTInterpreter methodsFor: 'versions' stamp: 'StephaneDucasse 10/1/2013 22:30'!
versionDEV: spec
	<version: '999-dev' imports: #('999-dev-baseline' )>

	"stable in Pharo 3.0"

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial dev version'.
		spec author: 'ClementBera'.
		spec timestamp: '2013-09-12'.
		"Authors: CamilloBruni ClementBera"
		spec  
			package: 'AST-Interpreter-Core'		with: 'AST-Interpreter-Core-CamilloBruni.111';
			package: 'AST-Interpreter-Extension'	with: 'AST-Interpreter-Extension-ClementBera.37';
			package: 'AST-Interpreter-PharoTest'	with: 'AST-Interpreter-PharoTest-ClementBera.11';
			package: 'AST-Interpreter-Test'		with: 'AST-Interpreter-Test-CamilloBruni.87';
			package: 'AST-Debugger'				with: 'AST-Debugger-ClementBera.6'].
! !
